#!/bin/bash
########################
#gedit+mspgcc+mspdebug
#chendianbuji@gmail.com
########################
function createPro(){
	local gmmPro=`zenity --name=gmm --class=gmm --file-selection --filename=*.gmm --file-filter=*.gmm --save --confirm-overwrite --title="新建MSP430工程"`
	
	#echo $gmmPro
	if [ "$gmmPro" != "" ] ;then
		local gmmPro=$gmmPro
		echo "正在生成: "$gmmPro
		echo "检测中..."
	else 
		echo "取消创建"
		return 2
	fi



	local gmmDir=${gmmPro%/*}
	local gmmProName=${gmmPro##*/}

	#检测当前目录下活动工程是否冲突
	#reLivePro=`ls -p -A $gmmDir|grep "^.GMMCLOCK$"`
	#if [ ${#reLivePro} -ne 0 ];then
	#	echo "ERROR: 当前目录下已有活动工程,无法在此目录重复创建" 
	#	zenity --error --text="请不要在同一目录(文件夹)下创建多个工程" --title="gmm-ERROR" --no-wrap
		#return 2
	#fi
	#ls -p -A -1|grep -v "$gmmProName"
	#echo $gmmProName
	#echo $gmmProName>$gmmPro
	echo "gmmDir="$gmmDir>$gmmPro
	local isProCreate=`echo $?`
	echo "gmmProName="$gmmProName>>$gmmPro
	#echo "isProCreate=$isProCreate"
	if [ $isProCreate -eq 0 ] ;then
		echo "成功生成: "$gmmPro
	else 
		echo "ERROR:未成功写入"
		return 2	
	fi

	#设置文件类型

	local gmmProMode0="c程序"
	local gmmProMode1="cpp程序"
	local gmmProType=`zenity --name=gmm --class=gmm $gmmProMode0 $gmmProMode1 --list --column="请选择工程类型(main函数所在文件后缀)" --text="MSP430工程" --title="工程设置"`

	#if [ ${#gmmProType} -eq 0 ] ; then
	#	echo "ERROR:未设置工程属性"
	#	return 2
	#fi
	case "${gmmProType}" in
		"c程序")
			echo "文件类型: "${gmmProType}
			echo "gmmProType=.c">>$gmmPro
			local mainType=".c"
			;;
		"cpp程序")
			echo "文件类型: "${gmmProType}
			echo "gmmProType=.cpp">>$gmmPro
			local mainType=".cpp"
			;;
		*)
			echo "ERROR: 未设置工程属性"
			return 2
			;;
	esac
	
	#设置器件型号
	local getLibPath=`cat ~/.gmm/.gmmrc |grep "^libPath="`
	local libPath=${getLibPath#*=}
	
	if [ ${#libPath} -eq 0 ] ; then
		zenity --error --no-wrap --title="错误信息" --text="ERROR: h文件库目录丢失，请重新设置"
		echo "ERROR: h文件库目录丢失，请重新设置"
		return 2;
	fi
	
	local mcuTypeList=`ls -p -A -1 $libPath|grep "^msp430"|grep ".h$"`

	local mcuHeadfile=`zenity --name=gmm --class=gmm --list --text="" --title="设置工程属性" --width=300 --height=500 --column="MSP430型号" $mcuTypeList`
	local mcuType=${mcuHeadfile%.*}
	if [ ${#mcuType} -eq 0 ] ; then
		echo "器件型号: 未设置"
		echo "取消创建"
		return 1
	else
		echo "mcuType=$mcuType">>$gmmPro
		echo "mcuHeadfile=$mcuHeadfile">>$gmmPro
		echo "器件型号: $mcuType"
	fi
	
	
	
	#设置下载方式
	local downloadMethod=`zenity --name=gmm --class=gmm --list --text="" --title="设置工程属性" --width=300 --height=240 --column="MSP430 Driver(下载方式)" "rf2500[USB LaunchPad]" "uif[FET430UIF JATG]"`
	if [ ${#downloadMethod} -eq 0 ] ; then
		echo "下载方式: 未设置"
		echo "取消创建"
		return 1
	else
		echo "downloadMethod=$downloadMethod">>$gmmPro
		echo "下载方式: $downloadMethod"
	fi
	
	
	
	local mainName=`zenity --name=gmm --class=gmm --entry --entry-text="main" --text="设置主文件名(无后缀,原同名文件将备份)" --title=" 工程设置"`
	if [ ${#mainName} -eq 0 ] ; then
		echo "取消设置"
		return 1
	else
		echo "开始创建: $mainName$mainType ..."
	fi
	
	local sameFile=`ls -p -A -1 $gmmDir|grep  "$mainName$mainType"|grep -v ".bak$"|grep -v "~$"`
	if [ ${#sameFile} -ne 0 ];then
		echo "当前目录: $sameFile 同名文件进行备份..."
		#cat $sameFile
		cat $gmmDir"/"$mainName$mainType>$gmmDir"/"$mainName$mainType".bak"
		local isBakCreate=`echo $?`
		#echo "isProCreate=$isProCreate"
		if [ $isBakCreate -eq 0 ] ;then
			echo "成功备份: "$gmmDir"/"$sameFile".bak"
		else 
			echo "ERROR:未成功备份"
			return 2	
		fi	
	fi
	
	echo "mainName=$mainName$mainType">>$gmmPro
	echo "主文件名: $mainName$mainType"
	echo "compileStyle=[auto on]">>$gmmPro
	echo "编译方式: [auto on]自动模式">>$gmmPro
	#notify-send "工程$gmmProName创建成功" "mcu型号:$mcuType"
	echo "#include \""$mcuHeadfile"\"">$gmmDir"/"$mainName$mainType
	if [ `echo $?` -eq 0 ] ; then
		echo "创建成功: $mainName$mainType"
	else
		echo "ERROR: $mainName$mainType创建失败"
		return 2
	fi
	cat ~/.gmm/.gmmrc|grep -v "libPath" >>$gmmDir"/"$mainName$mainType
	echo $mainName$mainType" 初始化..."
	echo $gmmPro>~/.gmm/.GMMCLOCK
	local isClockCreate=`echo $?`

	local liveProDir=`cat ~/.gmm/.GMMCLOCK`

	if [ $isClockCreate -eq 0 ] ;then
			echo "活动工程设置成功: "$gmmProName
			echo "successfulCreate">>$gmmPro
			notify-send "工程$gmmProName创建成功   型号:$mcuType" "当前活动工程  $liveProDir"
	else 
		echo "ERROR:活动工程设置失败 当前活动工程  $liveProDir"
		notify-send "工程$gmmProName创建成功   型号:$mcuType $gmmProName活动工程设置失败" "当前活动工程  $liveProDir"
		return 2	
	fi
	local mainName=`cat $gmmPro|grep "^mainName="`
	local mainName=${mainName#*=}
	local gmmDir=`cat $gmmPro|grep "^gmmDir="`
	local gmmDir=${gmmDir#*=}
	exec gedit $gmmDir"/"$mainName &
	#bash ~/.gmm/gmMenu.sh
}
createPro
exit

