#!/bin/bash
########################
#gedit+mspgcc+mspdebug
#chendianbuji@gmail.com
########################
function gmmCompile(){
	local liveProDir=`cat ~/.gmm/.GMMCLOCK`
	if [ ${#liveProDir} -eq 0 ] ; then
		echo "没有活动工程，请设置"
		return 2
	else
		echo "活动工程: $liveProDir"
	fi
	
	local gmmPro=$liveProDir
	
	local compileStyle=`cat $gmmPro|grep "^compileStyle="`
	local compileStyle=${compileStyle#*=}
	local autoSwitch=$compileStyle

	local gmmSuc=`cat $gmmPro|grep "^successfulCreate$"`
	if [ ${#gmmSuc} -eq 0 ] ; then
		echo "ERROR: 工程信息破损，无法使用"
		return 2
	fi
	
	local mcuType=`cat $gmmPro|grep "^mcuType="`
	local mcuType=${mcuType#*=}
	local mainName=`cat $gmmPro|grep "^mainName="`
	local mainName=${mainName#*=}
	local gmmDir=`cat $gmmPro|grep "^gmmDir="`
	local gmmDir=${gmmDir#*=}
	local gmmProType=`cat $gmmPro|grep "^gmmProType="`
	local gmmProType=${gmmProType#*=}
	local gmmProName=`cat $gmmPro|grep "^gmmProName="`
	local gmmProName=${gmmProName#*=}
	
	local gmmSuc=`cat $gmmPro|grep "^successfulCreate$"`
	if [ ${#gmmSuc} -eq 0 ] ; then
		echo "ERROR: 工程信息破损，无法使用"
		return 2
	fi
	
	
	if [ ${#mainName} -eq 0 ] ; then
		echo "ERROR: 工程信息丢失"
		return 0
	fi
	
	
	if [ "$compileStyle" = "[auto on]" ]	; then	
		echo "编译方式: [auto on]自动模式"
	else
		echo "编译方式: [auto off]手动模式"
	fi
	
	
	local isDebugExist=`ls -p|grep "/$"|grep "^debug/$"`
	if [ ${#isDebugExist} -eq 0 ] ; then
		rm -r $gmmDir/debug
		mkdir $gmmDir/debug
		echo "生成目录: $gmmDir/debug/"
	fi
	
	echo "">$gmmDir/debug/allList
	
		if [ "$compileStyle" = "[auto off]" ]	; then	
	
			local isLibFileExist=`cat $gmmDir/"."$gmmProName"libFile.lst"`
			
			if [ ${#isLibFileExist} -eq 0 ] ; then
				echo "配置文件: 未发现"
				local CURTIME=$(date +%Y-%m-%d" "%H":"%M":"%S)
				echo $CURTIME
				return 2
			else
				echo "包含路径: "
				echo "    "$gmmDir"/"$mainName
				cat $gmmDir/."$gmmProName"libFile.lst|awk '{print "    " $0}'
				local libFile=`cat $gmmDir/."$gmmProName"libFile.lst`
			fi
		
	else
		find $gmmDir|grep -P "$gmmProType$"|grep -v "$mainName$"|awk '{print "    " $0}'>$gmmDir/debug/allList
		
		echo ""
		echo "包含路径: "
		echo "    "$gmmDir"/"$mainName
		cat $gmmDir/debug/allList
		echo ""
	
		local libFile=`cat $gmmDir/debug/allList`
	fi
	
	
	
	
	
	
	
	echo "开始编译: $gmmDir/$mainName"
	
	#删除原有.elf文件
	local isElfExist=`ls -A -1 $gmmDir|grep "^${mainName%.*}.elf$"` 
	if [ ${#isElfExist} -ne 0 ] ; then
		rm $gmmDir/${mainName%.*}.elf
	fi
	
	local noMean=`exec msp430-gcc -os -mmcu=$mcuType $libFile $gmmDir"/"$mainName -o $gmmDir"/${mainName%.*}.elf"   &`
		
	local isElfCreate=`ls $gmmDir|grep "^${mainName%.*}.elf$"` 
	echo "检测中..."
	if [ ${#isElfCreate} -eq 0 ] ; then
		echo "未生成: ${mainName%.*}.elf"
		notify-send "编译失败" "未生成: ${mainName%.*}.elf"
	else
		echo "生成路径: $gmmDir/${mainName%.*}.elf"
		echo "确认生成: ${mainName%.*}.elf"
		notify-send "编译成功" "确认生成: ${mainName%.*}.elf"
	fi
	
	local CURTIME=$(date +%Y-%m-%d" "%H":"%M":"%S)
	echo $CURTIME
}

gmmCompile
exit
