#!/bin/bash
########################
#gedit+mspgcc+mspdebug
#chendianbuji@gmail.com
########################
function gmmDownload(){
	###############################################
	#防止多个gmmTerminal同时存在
	local pid=`ps -ef|grep "mspdebug - terminal "|grep -v "grep"|awk '{print $2}'`
	local pidArray=($pid)
	local pidNum=`ps -ef|grep "mspdebug - terminal "|grep -v "grep"|awk '{print $2}'|wc -l`
	#echo "pid="$pid
	if [ ${#pid} -ne 0 ] ; then
		for (( i = 0; i < pidNum; i++)); do
			exec kill ${pidArray[i]} &
			#echo ${pidArray[i]}
		done;
	fi
	################################################
	
	
	
	
	local liveProDir=`cat ~/.gmm/.GMMCLOCK`
	if [ ${#liveProDir} -eq 0 ] ; then
		echo "没有活动工程，请设置"
		return 2
	else
		echo "活动工程: $liveProDir"
	fi
	
	local gmmPro=$liveProDir
	local mcuType=`cat $gmmPro|grep "^mcuType="`
	local mcuType=${mcuType#*=}
	local mainName=`cat $gmmPro|grep "^mainName="`
	local mainName=${mainName#*=}
	local gmmDir=`cat $gmmPro|grep "^gmmDir="`
	local gmmDir=${gmmDir#*=}
	local downloadMethod=`cat $gmmPro|grep "^downloadMethod="`
	local downloadMethod=${downloadMethod#*=}
	local downloadCommand=""
	#sudo mspdebug -j -d /dev/ttyUSB0 uif
	#sudo mspdebug -j -d /dev/ttyACM0 uif
	local devName=(`ls -1 /dev|grep -P "^ttyACM|^ttyUSB"`)
	local devNum=`ls -1 /dev|grep -P "^ttyACM|^ttyUSB"|wc -l`
	local devChoose=${devName}
	#echo $devNum
	local serialName=""
	
	local compareNum=1
	if [ ${compareNum} -lt ${devNum} ] ; then 
		local devChoose=`zenity --name=gmm --class=gmm "${devName[0]}" "${devName[1]}" --list --column="请选择外设" --text="发现了一个以上的相关外设" --title="Gedit Mspgcc Mspdebug - GMM" --cancel-label="默认" --ok-label="确定"`
		if [ ${#devChoose} -eq 0 ] ; then
			local devChoose=${devName}
		fi
		local serialName=`ls -l -1 /dev/serial/by-id|grep "${devChoose}$"`
		#从下行中提取出下下行
		#lrwxrwxrwx 1 root root 13 8月 26 06:12 usb-Texas_Instruments_Texas_Instruments_MSP-FET430UIF_26FF467625922C25-if00 -> ../../ttyACM0
		#26FF467625922C25
		local serialName=${serialName##*_}
		local serialName=${serialName%%-*}
		
		echo "外设选择: ${devChoose}"
	elif [ ${devNum} -eq 0 ] ; then
		echo "目标路径: /dev"
		echo "ERROR: 未找到外设"
		notify-send "任务终止" "未找到外部设备"
		return 2
	fi
	local devName=$devChoose
	
	if [ ${#serialName} -eq 0 ] ; then 
		local serialName=""
	else
		local serialName="-s "$serialName
	fi

	
	#echo "serialName: $serialName"
	
	
	case "${downloadMethod}" in
		"rf2500[USB LaunchPad]")
			local downloadCommand="sudo mspdebug $serialName rf2500"
			;;
		"uif[FET430UIF JATG]")
			local downloadCommand="sudo mspdebug -j -d /dev/$devName uif"
			;;
		
		*)
		echo "ERROR: 未指明下载方式"
			return 2
			;;
	esac
	
	
	
	
	
	local gmmSuc=`cat $gmmPro|grep "^successfulCreate$"`
	if [ ${#gmmSuc} -eq 0 ] ; then
		echo "ERROR: 工程信息破损，无法使用"
		return 2
	fi
	
	#检查elf
	echo "检查文件: ${mainName%.*}.elf..."
	local elfName=`ls -1 $gmmDir|grep "^${mainName%.*}.elf$"`	
	if [ ${#elfName} -eq 0 ] ; then
		echo "ERROR: 未找到需要的.elf文件,请重新编译"
		return 2
	fi
	echo "发现文件: ${mainName%.*}.elf"
	
	local gmmDir=`cat $gmmPro|grep "^gmmDir="`
	local gmmDir=${gmmDir#*=}


	#local name=`echo $fullname | cut -d. -f1`
	#local dir=$GEDIT_CURRENT_DOCUMENT_DIR
	local CURTIME=$(date +%Y-%m-%d" "%H":"%M":"%S)
	echo Driver: $downloadMethod
	
	local noMeaning=`gnome-terminal --hide-menubar --working-directory=$gmmDir -t "mspdebug - terminal" -x bash -c "cd $gmmDir;echo 当前时间: $CURTIME;echo 活动工程: $liveProDir;echo 下载方式: $downloadMethod;echo 下载指令: prog ${mainName%.*}.elf;echo 运行指令: run;echo 帮助指令: help;echo 器件型号: $mcuType;echo 退出方法: 按住Ctrl+C;echo connecting msp430...;$downloadCommand;sleep 8"`
	return 1
	
}
gmmDownload
exit
