#!/bin/bash
########################
#gedit+mspgcc+mspdebug
#chendianbuji@gmail.com
########################
function gmmMakeCompileFiles(){

	local liveProDir=`cat ~/.gmm/.GMMCLOCK`
	if [ ${#liveProDir} -eq 0 ] ; then
		echo "没有活动工程，请设置"
		return 2
	else
		echo "活动工程: $liveProDir"
	fi
	
	local gmmPro=$liveProDir
	
	local exchangefile=${gmmPro%/*}"/.forStyleChange"$CURTIME
	echo "">$exchangefile
	#echo $exchangefile
	cat $gmmPro|grep -v "^compileStyle="|grep -v "^successfulCreate$">$exchangefile			
	cat $exchangefile>$gmmPro	
	rm $exchangefile
	
	echo "compileStyle=[auto off]">>$gmmPro
	echo "编译方式: [auto off]手动模式"
	echo "successfulCreate">>$gmmPro
	
	
	
	local mcuType=`cat $gmmPro|grep "^mcuType="`
	local mcuType=${mcuType#*=}
	local mainName=`cat $gmmPro|grep "^mainName="`
	local mainName=${mainName#*=}
	local gmmDir=`cat $gmmPro|grep "^gmmDir="`
	local gmmDir=${gmmDir#*=}
	local gmmProType=`cat $gmmPro|grep "^gmmProType="`
	local gmmProType=${gmmProType#*=}
	local gmmProName=`cat $gmmPro|grep "^gmmProName="`
	local gmmProName=${gmmProName#*=}
	
	
	local gmmSuc=`cat $gmmPro|grep "^successfulCreate$"`
	if [ ${#gmmSuc} -eq 0 ] ; then
		echo "ERROR: 工程信息破损，无法使用"
		return 2
	fi
	
	
	if [ ${#mainName} -eq 0 ] ; then
		echo "ERROR: 工程信息丢失"
		return 0
	fi
	
	
	#原配置列表文件是否存在
	local isListExist=`find $gmmDir|grep -P "^$gmmDir/."$gmmProName"libFile.lst$"`
	if [ ${#isListExist} -eq 0 ] ; then
		find $gmmDir|grep -P ".c$|.cpp$"|grep -v "$mainName$">$gmmDir/.${gmmProName}libFile.lst
	fi	

	local libFileNum=`find $gmmDir|grep -P ".c$|.cpp$"|grep -v "$mainName$"|wc -l`	
	local libFileArray=(`find $gmmDir|grep -P ".c$|.cpp$"|grep -v "$mainName$"|awk '{print  " TRUE " $0}'`)
	local libFile=""
	
	for (( i = 0; i < 2*libFileNum; i=i+2 )); do
		#echo ${#libFileArray[$i]}
		local isChooseBefore=`cat "$gmmDir/."$gmmProName"libFile.lst"|grep -P "${libFileArray[$i+1]}"`
		if [ ${#isChooseBefore} -eq 0 ] ; then
			local libFileArray[i]="FALSE"
		fi
		local libFile=${libFile}" "${libFileArray[i]}" "${libFileArray[i+1]}
		
	done
	
	


	if [ ${#libFile} -eq 0 ] ; then
		zenity --name=gmm --class=gmm --info --text="未发现需要参与编译的c,cpp文件" --no-wrap --icon-name="" --title="" --ok-label="无奈接受"
		#echo "hehe"	
		return 0
	fi
	cat $gmmDir/."$gmmProName"libFile.lst > $gmmDir/."$gmmProName"libFile.lst.bak
	`zenity --name=gmm --class=gmm --list --checklist --text="" --title="选择需要参与编译的文件" --width=700 --height=500 --multiple --column="参与编译" --column="列表(c,cpp)" $libFile --separator="\n">$gmmDir/."$gmmProName"libFile.lst`

	local isMakeStyleSuc=`cat $gmmDir/."$gmmProName"libFile.lst`
	if [ ${#isMakeStyleSuc} -eq 0 ] ; then
		cat $gmmDir/."$gmmProName"libFile.lst.bak>$gmmDir/."$gmmProName"libFile.lst
		rm $gmmDir/."$gmmProName"libFile.lst.bak
		echo "取消配置"
		exit
	fi
	rm $gmmDir/."$gmmProName"libFile.lst.bak
	
	
	
	local isLibFileExist=`ls -A -1 $gmmDir|grep "^."$gmmProName"libFile.lst$"`
	if [ ${#isLibFileExist} -eq 0 ] ; then
		echo "设置失败: 配置信息未生成"
		local CURTIME=$(date +%Y-%m-%d" "%H":"%M":"%S)
		echo $CURTIME
		return 2
	else
		echo "选中文件: "
		cat $gmmDir/."$gmmProName"libFile.lst|awk '{print "    " $0}'
	fi
	
	
	
	local CURTIME=$(date +%Y-%m-%d" "%H":"%M":"%S)
	echo $CURTIME

}
gmmMakeCompileFiles
exit

