#!/bin/bash
########################
#gedit+mspgcc+mspdebug
#chendianbuji@gmail.com
########################
function gmmTools(){
	local liveProDir=`cat ~/.gmm/.GMMCLOCK`
	if [ ${#liveProDir} -eq 0 ] ; then
		echo "没有活动工程，请设置"
		return 2
	else
		echo ""
	fi
	local gmmPro=$liveProDir


	local compileStyle=`cat $gmmPro|grep "^compileStyle="`
	local compileStyle=${compileStyle#*=}
	
	
	local setStyle=""
	if [ "$compileStyle" = "[auto on]" ]	; then	
		local autoSwitch="[自动模式]"
		local setSwitch="[开启手动模式并配置]"
	else
		local autoSwitch="[手动模式]"
		local setStyle="编译选项[重新配置]"
		local setSwitch="[关闭手动模式]"
	fi
	
	local gmmMenuOption=`zenity --name=gmm --class=gmm "编译链接$autoSwitch(Compile)" $setStyle "编译选项$setSwitch" "下载调试(Download & Debug)"  "返回" --list --column="工具菜单" --text="chendianbuji@gmail.com for help" --title="工具" --height=350 --width=280 --cancel-label="Exit" --ok-label="确定"`
	
	
	case "${gmmMenuOption}" in
		
		"编译链接[自动模式](Compile)")
			bash ~/.gmm/tools/gmmCompile.sh
			;;
		"编译链接[手动模式](Compile)")
			bash ~/.gmm/tools/gmmCompile.sh
		;;
		"编译选项[开启手动模式并配置]")
		
			bash ~/.gmm/tools/gmmMakeCompileFiles.sh
			;;
		"编译选项[重新配置]")
		
			bash ~/.gmm/tools/gmmMakeCompileFiles.sh
			;;
		"编译选项[关闭手动模式]")
		
			local exchangefile=${gmmPro%/*}"/.forStyleChange"$CURTIME
			echo "">$exchangefile
			#echo $exchangefile
			cat $gmmPro|grep -v "^compileStyle="|grep -v "^successfulCreate$">$exchangefile			
			cat $exchangefile>$gmmPro	
			rm $exchangefile
	
			echo "compileStyle=[auto on]">>$gmmPro
			echo "编译方式: [auto on]自动模式"
			echo "successfulCreate">>$gmmPro
			;;
		"下载调试(Download & Debug)")
			bash ~/.gmm/tools/gmmDownload.sh
			;;
			
		"返回")
			#echo "返回"
			return 0
			;;
		*)
			return 1
			;;
	esac
}
gmmTools
exit
